/*
  * reader.c
  * Simple program to read file into a config struct
  * gcc -Wall reader.c -o reader
  */
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include "reader.h"


struct config get_config(char *filename) 
 {
         struct config configstruct;
         FILE *file = fopen (filename, "r");

        if (file != NULL)
         { 
                 char line[MAXBUF];
                 int i = 0;

                while(fgets(line, sizeof(line), file) != NULL)
                 {
                         char *cfline;
                         cfline = strstr((char *)line,DELIM);
                         cfline = cfline + strlen(DELIM);
     
                         if (i == 0){
                                memcpy(configstruct.device,cfline,strlen(cfline));     
                            } else if (i == 1){
                                memcpy(configstruct.up,cfline,strlen(cfline));
                            } else if (i == 2){
                                memcpy(configstruct.down,cfline,strlen(cfline));
                            } else if (i == 3){
                                memcpy(configstruct.left,cfline,strlen(cfline));
                            } else if (i == 4){
                                memcpy(configstruct.right,cfline,strlen(cfline));
                            } else if (i == 5){
                                memcpy(configstruct.forward,cfline,strlen(cfline));
                            } else if (i == 6){
                                memcpy(configstruct.backward,cfline,strlen(cfline));
                                }    

                         i++;
                 } // End while
         } // End if file
         
         fclose(file);   
         
         return configstruct;

}

// Not the best solution, but working.

char *getDevice()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char* dev = (char *) malloc(sizeof(configstruct.device));
        memcpy(dev,configstruct.device, strlen(configstruct.device));
        strtok(dev, "\n"); // remove trailing linefeed
        return dev;
}

char getUp()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char ctrl[sizeof(configstruct.up)];
        memcpy(ctrl,configstruct.up, strlen(configstruct.up));
        return (char)* ctrl;
}

char getDown()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);   
        char ctrl[sizeof(configstruct.down)];      
        memcpy(ctrl,configstruct.down, strlen(configstruct.down));
        return (char)* ctrl;
}

char getLeft()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char ctrl[sizeof(configstruct.left)];
        memcpy(ctrl,configstruct.left, strlen(configstruct.left));
        return (char)* ctrl;
}

char getRight()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char ctrl[sizeof(configstruct.up)];
        memcpy(ctrl,configstruct.right, strlen(configstruct.right));
        return (char)* ctrl;
}

char getForward()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char ctrl[sizeof(configstruct.up)];
        memcpy(ctrl,configstruct.forward, strlen(configstruct.forward));
        return (char)* ctrl;
}

char getBackward()
{
        struct config configstruct;        
        configstruct = get_config(FILENAME);         
        char ctrl[sizeof(configstruct.up)];
        memcpy(ctrl,configstruct.backward, strlen(configstruct.backward));
        return (char)* ctrl;
}